/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Contents of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.298 - (show annotations) (download)
Fri Feb 13 01:30:50 2015 UTC (4 years, 8 months ago) by mpagano
Branch: MAIN
Changes since 1.297: +11 -1 lines
Handle cpu optimization patch for different gcc versions

1 # Copyright 1999-2014 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.297 2014/11/28 17:40:20 mpagano Exp $
4
5 # Description: kernel.eclass rewrite for a clean base regarding the 2.6
6 # series of kernel with back-compatibility for 2.4
7 #
8 # Original author: John Mylchreest <johnm@gentoo.org>
9 # Maintainer: kernel-misc@gentoo.org
10 #
11 # Please direct your bugs to the current eclass maintainer :)
12
13 # added functionality:
14 # unipatch - a flexible, singular method to extract, add and remove patches.
15
16 # A Couple of env vars are available to effect usage of this eclass
17 # These are as follows:
18 #
19 # K_USEPV - When setting the EXTRAVERSION variable, it should
20 # add PV to the end.
21 # this is useful for thigns like wolk. IE:
22 # EXTRAVERSION would be something like : -wolk-4.19-r1
23 # K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24 # automatically set within the kernel Makefile
25 # K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26 # first part of ${PN} in EXTRAVERSION
27 # K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28 # anything based on ${PR}.
29 # K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30 # ck-sources, ac-sources) it will use PR (ie: -r5) as
31 # the patchset version for
32 # and not use it as a true package revision
33 # K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34 # postinst and can be used to carry additional postinst
35 # messages
36 # K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
37 # K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38 # K_SYMLINK - if this is set, then forcably create symlink anyway
39 #
40 # K_DEFCONFIG - Allow specifying a different defconfig target.
41 # If length zero, defaults to "defconfig".
42 # K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43 # combination of "base", "extras" or "experimental".
44 # K_EXP_GENPATCHES_PULL - If set, we pull "experimental" regardless of the USE FLAG
45 # but expect the ebuild maintainer to use K_EXP_GENPATCHES_LIST.
46 # K_EXP_GENPATCHES_NOUSE - If set, no USE flag will be provided for "experimental";
47 # as a result the user cannot choose to apply those patches.
48 # K_EXP_GENPATCHES_LIST - A list of patches to pick from "experimental" to apply when
49 # the USE flag is unset and K_EXP_GENPATCHES_PULL is set.
50 # K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
51 # A value of "5" would apply genpatches-2.6.12-5 to
52 # my-sources-2.6.12.ebuild
53 # K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
54 # K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
55 # code. If empty, will be set to "1" if deblobbing is
56 # possible. Test ONLY for "1".
57 # K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
58 # If false, either optional deblobbing will be available
59 # or the license will note the inclusion of freedist
60 # code.
61 # K_LONGTERM - If set, the eclass will search for the kernel source
62 # in the long term directories on the upstream servers
63 # as the location has been changed by upstream
64 # H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
65 # can be supported by the headers ebuild
66
67 # UNIPATCH_LIST - space delimetered list of patches to be applied to the
68 # kernel
69 # UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
70 # on "<passedstring>*" and not "<passedno#>_*"
71 # - this should _NOT_ be used from the ebuild as this is
72 # reserved for end users passing excludes from the cli
73 # UNIPATCH_DOCS - space delimemeted list of docs to be installed to
74 # the doc dir
75 # UNIPATCH_STRICTORDER - if this is set places patches into directories of
76 # order, so they are applied in the order passed
77
78 # Changing any other variable in this eclass is not supported; you can request
79 # for additional variables to be added by contacting the current maintainer.
80 # If you do change them, there is a chance that we will not fix resulting bugs;
81 # that of course does not mean we're not willing to help.
82
83 PYTHON_COMPAT=( python{2_6,2_7} )
84
85 inherit eutils toolchain-funcs versionator multilib python-any-r1
86 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
87
88 # Added by Daniel Ostrow <dostrow@gentoo.org>
89 # This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
90 # I will remove it when I come up with something more reasonable.
91 [[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
92
93 export CTARGET=${CTARGET:-${CHOST}}
94 if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
95 export CTARGET=${CATEGORY/cross-}
96 fi
97
98 HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
99 : ${LICENSE:="GPL-2"}
100
101 # This is the latest KV_PATCH of the deblob tool available from the
102 # libre-sources upstream. If you bump this, you MUST regenerate the Manifests
103 # for ALL kernel-2 consumer packages where deblob is available.
104 : ${DEBLOB_MAX_VERSION:=38}
105
106 # No need to run scanelf/strip on kernel sources/headers (bug #134453).
107 RESTRICT="binchecks strip"
108
109 # set LINUX_HOSTCFLAGS if not already set
110 : ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
111
112 # debugging functions
113 #==============================================================
114 # this function exists only to help debug kernel-2.eclass
115 # if you are adding new functionality in, put a call to it
116 # at the start of src_unpack, or during SRC_URI/dep generation.
117 debug-print-kernel2-variables() {
118 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
119 RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
120 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
121 debug-print "${v}: ${!v}"
122 done
123 }
124
125 #Eclass functions only from here onwards ...
126 #==============================================================
127 handle_genpatches() {
128 local tarball
129 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
130
131 debug-print "Inside handle_genpatches"
132 local OKV_ARRAY
133 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
134
135 # for > 3.0 kernels, handle genpatches tarball name
136 # genpatches for 3.0 and 3.0.1 might be named
137 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
138 # respectively. Handle this.
139
140 for i in ${K_WANT_GENPATCHES} ; do
141 if [[ ${KV_MAJOR} -ge 3 ]]; then
142 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
143 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
144 else
145 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
146 fi
147 else
148 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
149 fi
150
151 local use_cond_start="" use_cond_end=""
152
153 if [[ "${i}" == "experimental" && -z ${K_EXP_GENPATCHES_PULL} && -z ${K_EXP_GENPATCHES_NOUSE} ]] ; then
154 use_cond_start="experimental? ( "
155 use_cond_end=" )"
156
157 if use experimental ; then
158 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
159 debug-print "genpatches tarball: $tarball"
160
161 # check gcc version < 4.9.X uses patch 5000 and = 4.9.X uses patch 5010
162 if [[ $(gcc-major-version) -eq 4 ]] && [[ $(gcc-minor-version) -ne 9 ]]; then
163 # drop 5000_enable-additional-cpu-optimizations-for-gcc-4.9.patch
164 UNIPATCH_EXCLUDE+=" 5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch"
165 else
166 #drop 5000_enable-additional-cpu-optimizations-for-gcc.patch
167 UNIPATCH_EXCLUDE+=" 5000_enable-additional-cpu-optimizations-for-gcc.patch"
168 fi
169
170 fi
171 else
172 UNIPATCH_LIST_GENPATCHES+=" ${DISTDIR}/${tarball}"
173 debug-print "genpatches tarball: $tarball"
174 fi
175
176 GENPATCHES_URI+=" ${use_cond_start}mirror://gentoo/${tarball}${use_cond_end}"
177 done
178 }
179
180 detect_version() {
181 # this function will detect and set
182 # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
183 # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
184 # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
185
186 # We've already run, so nothing to do here.
187 [[ -n ${KV_FULL} ]] && return 0
188
189 # CKV is used as a comparison kernel version, which is used when
190 # PV doesnt reflect the genuine kernel version.
191 # this gets set to the portage style versioning. ie:
192 # CKV=2.6.11_rc4
193 CKV=${CKV:-${PV}}
194 OKV=${OKV:-${CKV}}
195 OKV=${OKV/_beta/-test}
196 OKV=${OKV/_rc/-rc}
197 OKV=${OKV/-r*}
198 OKV=${OKV/_p*}
199
200 KV_MAJOR=$(get_version_component_range 1 ${OKV})
201 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
202 local OKV_ARRAY
203 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
204
205 # if KV_MAJOR >= 3, then we have no more KV_MINOR
206 #if [[ ${KV_MAJOR} -lt 3 ]]; then
207 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
208 KV_MINOR=$(get_version_component_range 2 ${OKV})
209 KV_PATCH=$(get_version_component_range 3 ${OKV})
210 if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
211 KV_EXTRA=$(get_version_component_range 4- ${OKV})
212 KV_EXTRA=${KV_EXTRA/[-_]*}
213 else
214 KV_PATCH=$(get_version_component_range 3- ${OKV})
215 fi
216 else
217 KV_PATCH=$(get_version_component_range 2 ${OKV})
218 KV_EXTRA=$(get_version_component_range 3- ${OKV})
219 KV_EXTRA=${KV_EXTRA/[-_]*}
220 fi
221
222 debug-print "KV_EXTRA is ${KV_EXTRA}"
223
224 KV_PATCH=${KV_PATCH/[-_]*}
225
226 local v n=0 missing
227 #if [[ ${KV_MAJOR} -lt 3 ]]; then
228 if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
229 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
230 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
231 done
232 else
233 for v in CKV OKV KV_{MAJOR,PATCH} ; do
234 [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
235 done
236 fi
237
238 [[ $n -eq 1 ]] && \
239 eerror "Missing variables: ${missing}" && \
240 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
241 unset v n missing
242
243 # if [[ ${KV_MAJOR} -ge 3 ]]; then
244 if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
245 KV_PATCH_ARR=(${KV_PATCH//\./ })
246
247 # at this point 031412, Linus is putting all 3.x kernels in a
248 # 3.x directory, may need to revisit when 4.x is released
249 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
250
251 [[ -n "${K_LONGTERM}" ]] &&
252 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
253 else
254 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
255 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
256 if [[ ${KV_MAJOR} -ge 3 ]]; then
257 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
258 else
259 KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
260 fi
261
262 [[ -n "${K_LONGTERM}" ]] &&
263 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
264 KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
265 fi
266
267 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
268
269 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
270 # handle non genpatch using sources correctly
271 if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
272 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
273 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
274 fi
275 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
276 else
277 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
278 fi
279
280 RELEASE=${CKV/${OKV}}
281 RELEASE=${RELEASE/_beta}
282 RELEASE=${RELEASE/_rc/-rc}
283 RELEASE=${RELEASE/_pre/-pre}
284 # We cannot trivally call kernel_is here, because it calls us to detect the
285 # version
286 #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
287 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
288 RELEASETYPE=${RELEASE//[0-9]}
289
290 # Now we know that RELEASE is the -rc/-git
291 # and RELEASETYPE is the same but with its numerics stripped
292 # we can work on better sorting EXTRAVERSION.
293 # first of all, we add the release
294 EXTRAVERSION="${RELEASE}"
295 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
296 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
297
298 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
299 if [[ -n "${K_NOUSEPR}" ]]; then
300 # Don't add anything based on PR to EXTRAVERSION
301 debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
302 elif [[ -n ${K_PREPATCHED} ]]; then
303 debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
304 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
305 elif [[ "${ETYPE}" = "sources" ]]; then
306 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
307 # For some sources we want to use the PV in the extra version
308 # This is because upstream releases with a completely different
309 # versioning scheme.
310 case ${PN/-*} in
311 wolk) K_USEPV=1;;
312 vserver) K_USEPV=1;;
313 esac
314
315 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
316 [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
317 [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
318 fi
319 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
320
321 # The only messing around which should actually effect this is for KV_EXTRA
322 # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
323 # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
324
325 if [[ -n ${KV_EXTRA} ]]; then
326 if [[ -n ${KV_MINOR} ]]; then
327 OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
328 else
329 OKV="${KV_MAJOR}.${KV_PATCH}"
330 fi
331 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
332 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
333 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
334 fi
335
336 # We need to set this using OKV, but we need to set it before we do any
337 # messing around with OKV based on RELEASETYPE
338 KV_FULL=${OKV}${EXTRAVERSION}
339
340 # we will set this for backwards compatibility.
341 S=${WORKDIR}/linux-${KV_FULL}
342 KV=${KV_FULL}
343
344 # -rc-git pulls can be achieved by specifying CKV
345 # for example:
346 # CKV="2.6.11_rc3_pre2"
347 # will pull:
348 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
349
350 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
351
352 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
353 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
354 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
355 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
356 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
357 fi
358
359 if [[ ${RELEASETYPE} == -git ]]; then
360 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
361 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
362 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
363 fi
364
365 if [[ ${RELEASETYPE} == -rc-git ]]; then
366 OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
367 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
368 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
369 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
370
371 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
372 fi
373 else
374 if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
375 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
376 OKV="2.6.39"
377 else
378 KV_PATCH_ARR=(${KV_PATCH//\./ })
379 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
380 fi
381 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
382 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
383 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
384 fi
385
386 if [[ ${RELEASETYPE} == -git ]]; then
387 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
388 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
389 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
390 fi
391
392 if [[ ${RELEASETYPE} == -rc-git ]]; then
393 if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
394 OKV="2.6.39"
395 else
396 KV_PATCH_ARR=(${KV_PATCH//\./ })
397 OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
398 fi
399 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
400 ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
401 ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
402
403 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
404 fi
405
406
407 fi
408
409
410 debug-print-kernel2-variables
411
412 handle_genpatches
413 }
414
415 # Note: duplicated in linux-info.eclass
416 kernel_is() {
417 # ALL of these should be set before we can safely continue this function.
418 # some of the sources have in the past had only one set.
419 local v n=0
420 for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
421 [[ $n -eq 1 ]] && detect_version
422 unset v n
423
424 # Now we can continue
425 local operator test value
426
427 case ${1#-} in
428 lt) operator="-lt"; shift;;
429 gt) operator="-gt"; shift;;
430 le) operator="-le"; shift;;
431 ge) operator="-ge"; shift;;
432 eq) operator="-eq"; shift;;
433 *) operator="-eq";;
434 esac
435 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
436
437 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
438 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
439 [ ${test} ${operator} ${value} ]
440 }
441
442 kernel_is_2_4() {
443 kernel_is 2 4
444 }
445
446 kernel_is_2_6() {
447 kernel_is 2 6 || kernel_is 2 5
448 }
449
450 # Capture the sources type and set DEPENDs
451 if [[ ${ETYPE} == sources ]]; then
452 DEPEND="!build? (
453 sys-apps/sed
454 >=sys-devel/binutils-2.11.90.0.31
455 )"
456 RDEPEND="!build? (
457 >=sys-libs/ncurses-5.2
458 sys-devel/make
459 dev-lang/perl
460 sys-devel/bc
461 )"
462 PDEPEND="!build? ( virtual/dev-manager )"
463
464 SLOT="${PVR}"
465 DESCRIPTION="Sources based on the Linux Kernel."
466 IUSE="symlink build"
467
468 # Bug #266157, deblob for libre support
469 if [[ -z ${K_PREDEBLOBBED} ]] ; then
470 # Bug #359865, force a call to detect_version if needed
471 kernel_is ge 2 6 27 && \
472 [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
473 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
474 K_DEBLOB_AVAILABLE=1
475 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
476 IUSE="${IUSE} deblob"
477
478 # Reflect that kernels contain firmware blobs unless otherwise
479 # stripped
480 LICENSE="${LICENSE} !deblob? ( freedist )"
481
482 DEPEND+=" deblob? ( ${PYTHON_DEPS} )"
483
484 if [[ -n KV_MINOR ]]; then
485 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
486 else
487 DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
488 fi
489
490 if [[ ${KV_MAJOR} -ge 3 ]]; then
491 DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
492 fi
493
494 DEBLOB_A="deblob-${DEBLOB_PV}"
495 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
496 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
497 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
498 if ! has "${EAPI:-0}" 0 1 ; then
499 DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
500 else
501 DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
502 fi
503 DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
504 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
505
506 KERNEL_URI="${KERNEL_URI}
507 deblob? (
508 ${DEBLOB_URI}
509 ${DEBLOB_CHECK_URI}
510 )"
511 else
512 # We have no way to deblob older kernels, so just mark them as
513 # tainted with non-libre materials.
514 LICENSE="${LICENSE} freedist"
515 fi
516 fi
517
518 elif [[ ${ETYPE} == headers ]]; then
519 DESCRIPTION="Linux system headers"
520
521 # Since we should NOT honour KBUILD_OUTPUT in headers
522 # lets unset it here.
523 unset KBUILD_OUTPUT
524
525 SLOT="0"
526 else
527 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
528 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
529 fi
530
531 # Cross-compile support functions
532 #==============================================================
533 kernel_header_destdir() {
534 [[ ${CTARGET} == ${CHOST} ]] \
535 && echo /usr/include \
536 || echo /usr/${CTARGET}/usr/include
537 }
538
539 cross_pre_c_headers() {
540 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
541 }
542
543 env_setup_xmakeopts() {
544 # Kernel ARCH != portage ARCH
545 export KARCH=$(tc-arch-kernel)
546
547 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
548 # variables properly or bad things happen !
549 xmakeopts="ARCH=${KARCH}"
550 if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
551 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
552 elif type -p ${CHOST}-ar > /dev/null ; then
553 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
554 fi
555 export xmakeopts
556 }
557
558 # Unpack functions
559 #==============================================================
560 unpack_2_4() {
561 # this file is required for other things to build properly,
562 # so we autogenerate it
563 make -s mrproper ${xmakeopts} || die "make mrproper failed"
564 make -s symlinks ${xmakeopts} || die "make symlinks failed"
565 make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
566 echo ">>> version.h compiled successfully."
567 }
568
569 unpack_2_6() {
570 # this file is required for other things to build properly, so we
571 # autogenerate it ... generate a .config to keep version.h build from
572 # spitting out an annoying warning
573 make -s mrproper ${xmakeopts} 2>/dev/null \
574 || die "make mrproper failed"
575
576 # quick fix for bug #132152 which triggers when it cannot include linux
577 # headers (ie, we have not installed it yet)
578 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
579 touch .config
580 eerror "make defconfig failed."
581 eerror "assuming you dont have any headers installed yet and continuing"
582 epause 5
583 fi
584
585 make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
586 || die "make include/linux/version.h failed"
587 rm -f .config >/dev/null
588 }
589
590 universal_unpack() {
591 debug-print "Inside universal_unpack"
592
593 local OKV_ARRAY
594 IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
595
596 cd "${WORKDIR}"
597 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
598 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
599 else
600 unpack linux-${OKV}.tar.xz
601 fi
602
603 if [[ -d "linux" ]]; then
604 debug-print "Moving linux to linux-${KV_FULL}"
605 mv linux linux-${KV_FULL} \
606 || die "Unable to move source tree to ${KV_FULL}."
607 elif [[ "${OKV}" != "${KV_FULL}" ]]; then
608 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
609 [[ "${ETYPE}" = "sources" ]]; then
610 debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
611 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
612 || die "Unable to move source tree to ${KV_FULL}."
613 else
614 debug-print "moving linux-${OKV} to linux-${KV_FULL} "
615 mv linux-${OKV} linux-${KV_FULL} \
616 || die "Unable to move source tree to ${KV_FULL}."
617 fi
618 elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
619 mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
620 || die "Unable to move source tree to ${KV_FULL}."
621 fi
622 cd "${S}"
623
624 # remove all backup files
625 find . -iname "*~" -exec rm {} \; 2> /dev/null
626
627 }
628
629 unpack_set_extraversion() {
630 cd "${S}"
631 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
632 cd "${OLDPWD}"
633 }
634
635 # Should be done after patches have been applied
636 # Otherwise patches that modify the same area of Makefile will fail
637 unpack_fix_install_path() {
638 cd "${S}"
639 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
640 }
641
642 # Compile Functions
643 #==============================================================
644 compile_headers() {
645 env_setup_xmakeopts
646
647 # if we couldnt obtain HOSTCFLAGS from the Makefile,
648 # then set it to something sane
649 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
650 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
651
652 if kernel_is 2 4; then
653 yes "" | make oldconfig ${xmakeopts}
654 echo ">>> make oldconfig complete"
655 make dep ${xmakeopts}
656 elif kernel_is 2 6; then
657 # 2.6.18 introduces headers_install which means we dont need any
658 # of this crap anymore :D
659 kernel_is ge 2 6 18 && return 0
660
661 # autoconf.h isnt generated unless it already exists. plus, we have
662 # no guarantee that any headers are installed on the system...
663 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
664 || touch include/linux/autoconf.h
665
666 # if K_DEFCONFIG isn't set, force to "defconfig"
667 # needed by mips
668 if [[ -z ${K_DEFCONFIG} ]]; then
669 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
670 case ${CTARGET} in
671 powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
672 powerpc*) K_DEFCONFIG="pmac32_defconfig";;
673 *) K_DEFCONFIG="defconfig";;
674 esac
675 else
676 K_DEFCONFIG="defconfig"
677 fi
678 fi
679
680 # if there arent any installed headers, then there also isnt an asm
681 # symlink in /usr/include/, and make defconfig will fail, so we have
682 # to force an include path with $S.
683 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
684 ln -sf asm-${KARCH} "${S}"/include/asm
685 cross_pre_c_headers && return 0
686
687 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
688 if compile_headers_tweak_config ; then
689 yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
690 fi
691 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
692 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
693 fi
694 }
695
696 compile_headers_tweak_config() {
697 # some targets can be very very picky, so let's finesse the
698 # .config based upon any info we may have
699 case ${CTARGET} in
700 sh*)
701 sed -i '/CONFIG_CPU_SH/d' .config
702 echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
703 return 0;;
704 esac
705
706 # no changes, so lets do nothing
707 return 1
708 }
709
710 # install functions
711 #==============================================================
712 install_universal() {
713 # Fix silly permissions in tarball
714 cd "${WORKDIR}"
715 chown -R 0:0 * >& /dev/null
716 chmod -R a+r-w+X,u+w *
717 cd ${OLDPWD}
718 }
719
720 install_headers() {
721 local ddir=$(kernel_header_destdir)
722
723 # 2.6.18 introduces headers_install which means we dont need any
724 # of this crap anymore :D
725 if kernel_is ge 2 6 18 ; then
726 env_setup_xmakeopts
727 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
728
729 # let other packages install some of these headers
730 rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
731 return 0
732 fi
733
734 # Do not use "linux/*" as that can cause problems with very long
735 # $S values where the cmdline to cp is too long
736 pushd "${S}" >/dev/null
737 dodir ${ddir}/linux
738 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
739 rm -rf "${D}"/${ddir}/linux/modules
740
741 dodir ${ddir}/asm
742 cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
743
744 if kernel_is 2 6 ; then
745 dodir ${ddir}/asm-generic
746 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
747 fi
748
749 # clean up
750 find "${D}" -name '*.orig' -exec rm -f {} \;
751
752 popd >/dev/null
753 }
754
755 install_sources() {
756 local file
757
758 cd "${S}"
759 dodir /usr/src
760 echo ">>> Copying sources ..."
761
762 file="$(find ${WORKDIR} -iname "docs" -type d)"
763 if [[ -n ${file} ]]; then
764 for file in $(find ${file} -type f); do
765 echo "${file//*docs\/}" >> "${S}"/patches.txt
766 echo "===================================================" >> "${S}"/patches.txt
767 cat ${file} >> "${S}"/patches.txt
768 echo "===================================================" >> "${S}"/patches.txt
769 echo "" >> "${S}"/patches.txt
770 done
771 fi
772
773 if [[ ! -f ${S}/patches.txt ]]; then
774 # patches.txt is empty so lets use our ChangeLog
775 [[ -f ${FILESDIR}/../ChangeLog ]] && \
776 echo "Please check the ebuild ChangeLog for more details." \
777 > "${S}"/patches.txt
778 fi
779
780 mv ${WORKDIR}/linux* "${D}"/usr/src
781
782 if [[ -n "${UNIPATCH_DOCS}" ]] ; then
783 for i in ${UNIPATCH_DOCS}; do
784 dodoc "${T}"/${i}
785 done
786 fi
787 }
788
789 # pkg_preinst functions
790 #==============================================================
791 preinst_headers() {
792 local ddir=$(kernel_header_destdir)
793 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
794 [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
795 }
796
797 # pkg_postinst functions
798 #==============================================================
799 postinst_sources() {
800 local MAKELINK=0
801
802 # if we have USE=symlink, then force K_SYMLINK=1
803 use symlink && K_SYMLINK=1
804
805 # if we're using a deblobbed kernel, it's not supported
806 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
807 use deblob && \
808 K_SECURITY_UNSUPPORTED=deblob
809
810 # if we are to forcably symlink, delete it if it already exists first.
811 if [[ ${K_SYMLINK} > 0 ]]; then
812 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
813 MAKELINK=1
814 fi
815
816 # if the link doesnt exist, lets create it
817 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
818
819 if [[ ${MAKELINK} == 1 ]]; then
820 cd "${ROOT}"usr/src
821 ln -sf linux-${KV_FULL} linux
822 cd ${OLDPWD}
823 fi
824
825 # Don't forget to make directory for sysfs
826 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
827
828 echo
829 elog "If you are upgrading from a previous kernel, you may be interested"
830 elog "in the following document:"
831 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
832 echo
833
834 # if K_EXTRAEINFO is set then lets display it now
835 if [[ -n ${K_EXTRAEINFO} ]]; then
836 echo ${K_EXTRAEINFO} | fmt |
837 while read -s ELINE; do einfo "${ELINE}"; done
838 fi
839
840 # if K_EXTRAELOG is set then lets display it now
841 if [[ -n ${K_EXTRAELOG} ]]; then
842 echo ${K_EXTRAELOG} | fmt |
843 while read -s ELINE; do elog "${ELINE}"; done
844 fi
845
846 # if K_EXTRAEWARN is set then lets display it now
847 if [[ -n ${K_EXTRAEWARN} ]]; then
848 echo ${K_EXTRAEWARN} | fmt |
849 while read -s ELINE; do ewarn "${ELINE}"; done
850 fi
851
852 # optionally display security unsupported message
853 # Start with why
854 if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
855 ewarn "Deblobbed kernels may not be up-to-date security-wise"
856 ewarn "as they depend on external scripts."
857 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
858 ewarn "${PN} is UNSUPPORTED by Gentoo Security."
859 fi
860 # And now the general message.
861 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
862 ewarn "This means that it is likely to be vulnerable to recent security issues."
863 ewarn "For specific information on why this kernel is unsupported, please read:"
864 ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
865 fi
866
867 # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
868 KV_MAJOR=$(get_version_component_range 1 ${OKV})
869 KV_MINOR=$(get_version_component_range 2 ${OKV})
870 KV_PATCH=$(get_version_component_range 3 ${OKV})
871 if [[ "$(tc-arch)" = "sparc" ]]; then
872 if [[ $(gcc-major-version) -lt 4 && $(gcc-minor-version) -lt 4 ]]; then
873 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]] ; then
874 echo
875 elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
876 elog "you now need to do"
877 elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
878 elog "instead of just"
879 elog " make"
880 elog "to compile the kernel. For more information please browse to"
881 elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
882 echo
883 fi
884 fi
885 fi
886 }
887
888 # pkg_setup functions
889 #==============================================================
890 setup_headers() {
891 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
892 for i in ${H_SUPPORTEDARCH}; do
893 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
894 done
895
896 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
897 echo
898 eerror "This version of ${PN} does not support $(tc-arch)."
899 eerror "Please merge the appropriate sources, in most cases"
900 eerror "(but not all) this will be called $(tc-arch)-headers."
901 die "Package unsupported for $(tc-arch)"
902 fi
903 }
904
905 # unipatch
906 #==============================================================
907 unipatch() {
908 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
909 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
910
911 # set to a standard locale to ensure sorts are ordered properly.
912 myLC_ALL="${LC_ALL}"
913 myLANG="${LANG}"
914 LC_ALL="C"
915 LANG=""
916
917 [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
918 [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
919
920 # We're gonna need it when doing patches with a predefined patchlevel
921 eshopts_push -s extglob
922
923 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
924 # usage can be either via an env var or by params
925 # although due to the nature we pass this within this eclass
926 # it shall be by param only.
927 # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
928 UNIPATCH_LIST="${@}"
929
930 #unpack any passed tarballs
931 for i in ${UNIPATCH_LIST}; do
932 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
933 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
934 unset z
935 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
936 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
937 do z="${z}0";
938 done
939 PATCH_ORDER="${z}${STRICT_COUNT}"
940
941 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
942 pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
943 unpack ${i##*/}
944 popd >/dev/null
945 else
946 pushd "${KPATCH_DIR}" >/dev/null
947 unpack ${i##*/}
948 popd >/dev/null
949 fi
950
951 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
952 else
953 extention=${i/*./}
954 extention=${extention/:*/}
955 PIPE_CMD=""
956 case ${extention} in
957 xz) PIPE_CMD="xz -dc";;
958 lzma) PIPE_CMD="lzma -dc";;
959 bz2) PIPE_CMD="bzip2 -dc";;
960 patch*) PIPE_CMD="cat";;
961 diff) PIPE_CMD="cat";;
962 gz|Z|z) PIPE_CMD="gzip -dc";;
963 ZIP|zip) PIPE_CMD="unzip -p";;
964 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
965 esac
966
967 PATCH_LEVEL=${i/*([^:])?(:)}
968 i=${i/:*/}
969 x=${i/*\//}
970 x=${x/\.${extention}/}
971
972 if [ -n "${PIPE_CMD}" ]; then
973 if [ ! -r "${i}" ]; then
974 echo
975 eerror "FATAL: unable to locate:"
976 eerror "${i}"
977 eerror "for read-only. The file either has incorrect permissions"
978 eerror "or does not exist."
979 die Unable to locate ${i}
980 fi
981
982 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
983 unset z
984 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
985 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
986 do z="${z}0";
987 done
988 PATCH_ORDER="${z}${STRICT_COUNT}"
989
990 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
991 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
992 else
993 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
994 fi
995 fi
996 fi
997
998 # If experimental was not chosen by the user, drop experimental patches not in K_EXP_GENPATCHES_LIST.
999 if [[ "${i}" == *"genpatches-"*".experimental."* && -n ${K_EXP_GENPATCHES_PULL} ]] ; then
1000 if [[ -z ${K_EXP_GENPATCHES_NOUSE} ]] && use experimental; then
1001 continue
1002 fi
1003
1004 local j
1005 for j in ${KPATCH_DIR}/*/50*_*.patch*; do
1006 for k in ${K_EXP_GENPATCHES_LIST} ; do
1007 [[ "$(basename ${j})" == ${k}* ]] && continue 2
1008 done
1009 UNIPATCH_DROP+=" $(basename ${j})"
1010 done
1011 fi
1012 done
1013
1014 #populate KPATCH_DIRS so we know where to look to remove the excludes
1015 x=${KPATCH_DIR}
1016 KPATCH_DIR=""
1017 for i in $(find ${x} -type d | sort -n); do
1018 KPATCH_DIR="${KPATCH_DIR} ${i}"
1019 done
1020
1021 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
1022 # bug #272676
1023 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
1024 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
1025 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
1026 echo
1027 ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
1028 ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
1029 ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
1030 echo
1031 fi
1032 fi
1033
1034 #so now lets get rid of the patchno's we want to exclude
1035 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
1036 for i in ${UNIPATCH_DROP}; do
1037 ebegin "Excluding Patch #${i}"
1038 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
1039 eend $?
1040 done
1041
1042 # and now, finally, we patch it :)
1043 for x in ${KPATCH_DIR}; do
1044 for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
1045 STDERR_T="${T}/${i/*\//}"
1046 STDERR_T="${STDERR_T/.patch*/.err}"
1047
1048 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
1049 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
1050
1051 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
1052
1053 ####################################################################
1054 # IMPORTANT: This is temporary code to support Linux git 3.15_rc1! #
1055 # #
1056 # The patch contains a removal of a symlink, followed by addition #
1057 # of a file with the same name as the symlink in the same #
1058 # location; this causes the dry-run to fail, filed bug #507656. #
1059 # #
1060 # https://bugs.gentoo.org/show_bug.cgi?id=507656 #
1061 ####################################################################
1062 if [[ ${PN} == "git-sources" ]] ; then
1063 if [[ ${KV_MAJOR}${KV_PATCH} -ge 315 && ${RELEASETYPE} == -rc ]] ; then
1064 ebegin "Applying ${i/*\//} (-p1)"
1065 if [ $(patch -p1 --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1066 eend 0
1067 rm ${STDERR_T}
1068 break
1069 else
1070 eend 1
1071 eerror "Failed to apply patch ${i/*\//}"
1072 eerror "Please attach ${STDERR_T} to any bug you may post."
1073 eshopts_pop
1074 die "Failed to apply ${i/*\//} on patch depth 1."
1075 fi
1076 fi
1077 fi
1078 ####################################################################
1079
1080 while [ ${PATCH_DEPTH} -lt 5 ]; do
1081 echo "Attempting Dry-run:" >> ${STDERR_T}
1082 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
1083 echo "=======================================================" >> ${STDERR_T}
1084 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
1085 ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH})"
1086 echo "Attempting patch:" > ${STDERR_T}
1087 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
1088 echo "=======================================================" >> ${STDERR_T}
1089 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
1090 eend 0
1091 rm ${STDERR_T}
1092 break
1093 else
1094 eend 1
1095 eerror "Failed to apply patch ${i/*\//}"
1096 eerror "Please attach ${STDERR_T} to any bug you may post."
1097 eshopts_pop
1098 die "Failed to apply ${i/*\//} on patch depth ${PATCH_DEPTH}."
1099 fi
1100 else
1101 PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
1102 fi
1103 done
1104 if [ ${PATCH_DEPTH} -eq 5 ]; then
1105 eerror "Failed to dry-run patch ${i/*\//}"
1106 eerror "Please attach ${STDERR_T} to any bug you may post."
1107 eshopts_pop
1108 die "Unable to dry-run patch on any patch depth lower than 5."
1109 fi
1110 done
1111 done
1112
1113 # When genpatches is used, we want to install 0000_README which documents
1114 # the patches that were used; such that the user can see them, bug #301478.
1115 if [[ ! -z ${K_WANT_GENPATCHES} ]] ; then
1116 UNIPATCH_DOCS="${UNIPATCH_DOCS} 0000_README"
1117 fi
1118
1119 # When files listed in UNIPATCH_DOCS are found in KPATCH_DIR's, we copy it
1120 # to the temporary directory and remember them in UNIPATCH_DOCS to install
1121 # them during the install phase.
1122 local tmp
1123 for x in ${KPATCH_DIR}; do
1124 for i in ${UNIPATCH_DOCS}; do
1125 if [[ -f "${x}/${i}" ]] ; then
1126 tmp="${tmp} ${i}"
1127 cp -f "${x}/${i}" "${T}"/
1128 fi
1129 done
1130 done
1131 UNIPATCH_DOCS="${tmp}"
1132
1133 # clean up KPATCH_DIR's - fixes bug #53610
1134 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1135
1136 LC_ALL="${myLC_ALL}"
1137 LANG="${myLANG}"
1138 eshopts_pop
1139 }
1140
1141 # getfilevar accepts 2 vars as follows:
1142 # getfilevar <VARIABLE> <CONFIGFILE>
1143 # pulled from linux-info
1144
1145 getfilevar() {
1146 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1147
1148 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1149 echo -e "\n"
1150 eerror "getfilevar requires 2 variables, with the second a valid file."
1151 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1152 else
1153 workingdir=${PWD}
1154 basefname=$(basename ${2})
1155 basedname=$(dirname ${2})
1156 unset ARCH
1157
1158 cd ${basedname}
1159 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1160 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1161 cd ${workingdir}
1162
1163 ARCH=${xarch}
1164 fi
1165 }
1166
1167 detect_arch() {
1168 # This function sets ARCH_URI and ARCH_PATCH
1169 # with the neccessary info for the arch sepecific compatibility
1170 # patchsets.
1171
1172 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1173
1174 # COMPAT_URI is the contents of ${ARCH}_URI
1175 # ARCH_URI is the URI for all the ${ARCH}_URI patches
1176 # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1177
1178 ARCH_URI=""
1179 ARCH_PATCH=""
1180 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1181
1182 for LOOP_ARCH in ${ALL_ARCH}; do
1183 COMPAT_URI="${LOOP_ARCH}_URI"
1184 COMPAT_URI="${!COMPAT_URI}"
1185
1186 [[ -n ${COMPAT_URI} ]] && \
1187 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1188
1189 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1190 for i in ${COMPAT_URI}; do
1191 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1192 done
1193 fi
1194 done
1195 }
1196
1197 headers___fix() {
1198 # Voodoo to partially fix broken upstream headers.
1199 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1200 sed -i \
1201 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1202 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1203 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1204 -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1205 -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1206 "$@"
1207 }
1208
1209 # common functions
1210 #==============================================================
1211 kernel-2_src_unpack() {
1212 universal_unpack
1213 debug-print "Doing unipatch"
1214
1215 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1216 unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1217
1218 debug-print "Doing premake"
1219
1220 # allow ebuilds to massage the source tree after patching but before
1221 # we run misc `make` functions below
1222 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1223
1224 debug-print "Doing epatch_user"
1225 epatch_user
1226
1227 debug-print "Doing unpack_set_extraversion"
1228
1229 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1230 unpack_fix_install_path
1231
1232 # Setup xmakeopts and cd into sourcetree.
1233 env_setup_xmakeopts
1234 cd "${S}"
1235
1236 # We dont need a version.h for anything other than headers
1237 # at least, I should hope we dont. If this causes problems
1238 # take out the if/fi block and inform me please.
1239 # unpack_2_6 should now be 2.6.17 safe anyways
1240 if [[ ${ETYPE} == headers ]]; then
1241 kernel_is 2 4 && unpack_2_4
1242 kernel_is 2 6 && unpack_2_6
1243 fi
1244
1245 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1246 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1247 cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1248 chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1249 fi
1250
1251 # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1252 # only do this for kernel < 2.6.27 since this file does not exist in later
1253 # kernels
1254 if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]] ; then
1255 sed -i \
1256 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1257 "${S}"/arch/ppc/Makefile
1258 else
1259 sed -i \
1260 -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1261 "${S}"/arch/powerpc/Makefile
1262 fi
1263 }
1264
1265 kernel-2_src_compile() {
1266 cd "${S}"
1267 [[ ${ETYPE} == headers ]] && compile_headers
1268
1269 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1270 echo ">>> Running deblob script ..."
1271 python_setup
1272 sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1273 fi
1274 }
1275
1276 # if you leave it to the default src_test, it will run make to
1277 # find whether test/check targets are present; since "make test"
1278 # actually produces a few support files, they are installed even
1279 # though the package is binchecks-restricted.
1280 #
1281 # Avoid this altogether by making the function moot.
1282 kernel-2_src_test() { :; }
1283
1284 kernel-2_pkg_preinst() {
1285 [[ ${ETYPE} == headers ]] && preinst_headers
1286 }
1287
1288 kernel-2_src_install() {
1289 install_universal
1290 [[ ${ETYPE} == headers ]] && install_headers
1291 [[ ${ETYPE} == sources ]] && install_sources
1292 }
1293
1294 kernel-2_pkg_postinst() {
1295 [[ ${ETYPE} == sources ]] && postinst_sources
1296 }
1297
1298 kernel-2_pkg_setup() {
1299 if kernel_is 2 4; then
1300 if [[ $(gcc-major-version) -ge 4 ]] ; then
1301 echo
1302 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1303 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1304 ewarn "newer kernel that supports gcc-4."
1305 echo
1306 ewarn "Also be aware that bugreports about gcc-4 not working"
1307 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1308 echo
1309 epause 10
1310 fi
1311 fi
1312
1313 ABI="${KERNEL_ABI}"
1314 [[ ${ETYPE} == headers ]] && setup_headers
1315 [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1316 }
1317
1318 kernel-2_pkg_postrm() {
1319 # This warning only makes sense for kernel sources.
1320 [[ ${ETYPE} == headers ]] && return 0
1321
1322 # If there isn't anything left behind, then don't complain.
1323 [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1324 echo
1325 ewarn "Note: Even though you have successfully unmerged "
1326 ewarn "your kernel package, directories in kernel source location: "
1327 ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1328 ewarn "with modified files will remain behind. By design, package managers"
1329 ewarn "will not remove these modified files and the directories they reside in."
1330 echo
1331 }

  ViewVC Help
Powered by ViewVC 1.1.20